//
// utils.cpp
// Some helper utilities 
//

#include "stdafx.h"


        WORD    rand_current = 49587, rand_A = 12347, rand_C = 20087;


// Rounds double to nearest integer
//
double  round ( double a ) 
{
    double c = ceil(a);
    double f = floor(a);
    if ((a-f) < (c-a)) return f;
    return c;
}

// Get random number
//
int     MyRandom  ( int l, int r )
{
        //DWORD   t;
        //t = ((DWORD)rand_current * rand_A) + rand_C;
        //t = t & 0xFFFF;
        //rand_current = (WORD)(t & 0xFFFF);
        //return( l + (WORD)((t*(r-l))/0xFFFF) );
        double d = (rand()*(r-l+1))/(RAND_MAX+1.0);
        return l + (int)floor(d);
}

// Initialize random-number generator
//
void    MyRandomize       ( void )
{
        //DWORD d = GetTickCount();
        //rand_current ^= ((d & 0xFFFF) ^ (d >> 16));
        srand( (unsigned)GetTickCount() );
}


// CStringList simple sorting 
//
void BubbleSort (CStringList *slStrings)
{
    POSITION endpos = slStrings->GetTailPosition();
    for (int i=1; i<slStrings->GetCount(); i++) 
    {
        bool changed = false;
        POSITION pos2;
        POSITION pos1 = slStrings->GetHeadPosition();
        while ((pos2=pos1) != endpos) 
        {
            CString str1 = slStrings->GetNext(pos1);
            CString str2 = slStrings->GetAt(pos1);
            if (wcscmp(str1, str2) > 0) {
                slStrings->SetAt(pos2, str2);
                slStrings->SetAt(pos1, str1);
                changed = true;
            }
        }
        if (!changed) return;
        slStrings->GetPrev(endpos);
    }
} 

// reads a line of 1-byte characters from file to unicode string
//
BOOL read_ansi_string( HANDLE f, CString * s, int maxlen )
{
	DWORD	dw;
	char	c;
	int		j;

    j = 0;
	*s = L"";
	while (1)
	{
	  ReadFile(f, &c, 1, &dw, NULL);
	  if (dw != 1) return TRUE;
	  if (c == 0x0A) break;
	  if ((c != 0x0D) && (j<maxlen)) { *s = *s + TCHAR(c); j++; }
	}
    return FALSE;
}

// Transform string into simple-word-wrapped string (newlines are marked with "\")
// returns: lines count
//
int simple_word_wrap ( CString * s, int max_width )
{
    int l = s->GetLength();
    LPTSTR sbuf = s->GetBuffer(0);
    int last_space_pos = -1;
    int cur_width = 0;
    int lines_count = 1;
    int i = 0;
    while (i<l) {
      if ((sbuf[i] == 0x20) || (sbuf[i] == '_')) last_space_pos = i;
      if (cur_width > max_width) {
        if ((last_space_pos >= 0) && (sbuf[last_space_pos] != '\\')) {
          sbuf[last_space_pos] = '\\';
          cur_width = i - last_space_pos-1;
          lines_count++;
        }
      }
      i++;
      cur_width++;
    }
    s->ReleaseBuffer();
    return lines_count;
}
