<?php
    $infname = 'wait_240.png';

    list($dx, $dy) = getimagesize($infname);
    $img = ImageCreateFromPng($infname);

    $g = fopen($infname.'.txt', 'w');

    $k = 1;
    for ($i=0; $i<$dy; $i++)
      for ($j=0; $j<$dx; $j++) {
        $rgb = ImageColorAt($img, $j, $i);

        $cr = ($rgb >> 16) & 0xFF;  // Red   (0..255)
        $cg = ($rgb >> 8) & 0xFF;   // Green (0..255)
        $cb = $rgb & 0xFF;          // Blue  (0..255)

        $cr = $cr >> 3; // Red   5-bits
        $cg = $cg >> 2; // Green 6-bits
        $cb = $cb >> 3; // Blue  5-bits

        fwrite($g, '0x'.dechex(($cr<<11) + ($cg<<5) + ($cb)).', ');
        if ($k > 240) {
           fwrite($g, chr(0x0D).chr(0x0A).chr(0x09));
           $k = 0;
        }
        $k++;
      }

    fclose($g);
?>